;-------------------------------------------------------------------------
; PENCERE.LSP
; by Hakan BAYKARA  Ins. Muh. (ITU)
; AGUSTOS 1993
; Gorunus ve kesitlere 3 ayri tip pencere cizer.
; Tek bir "Pencere" komutuna baglanmistir.
;--------------------------------------------------------------------------
; Kolay tekrar yukleme yapar

(setq pen-1      nil  
      pen-2      nil
      pen-3      nil
      cizerr     nil
      C:Pencere  nil)

;--------------------------------------------------------------------------
; Sistem degiskenlerinin kaydedilmesi.

(defun modes (a)
   (setq MLST nil)
   (repeat (length a)
      (setq MLST (append MLST (list (list (car a) (getvar (car a))))))
      (setq a (cdr a))
   )
)

;--------------------------------------------------------------------------
; Sistem degiskenlerinin geri yuklenmesi.

(defun moder ()
   (repeat (length MLST)
      (setvar (caar MLST) (cadar MLST))
      (setq MLST (cdr MLST))
   )
)

;--------------------------------------------------------------------------
;Kanatsiz pencere cizimi

(defun pen-1 (/ ph pb pt1 pt2 pt3 pt4 pd1 pd2 pd3 pd4)
   
   (command "LINETYPE" "S" "continuous" "")
   (initget 6)   
   (setq ph (getint "\nPencerenin [H] boyutunu <cm.> ver : "))
   (initget 6)   
   (setq pb (getint "\nPencerenin [B] boyutunu <cm.> ver : "))
   (initget 17)   
   (setq pt1 (getpoint "\nPencere ciziminin sol-alt kosesini isaretle: "))
   
   (setq ph (/ ph 100.0))
   (setq pb (/ pb 100.0))

   (setq pt2 (list (+ (car pt1) pb) (cadr pt1)))
   (setq pt3 (list (car pt2) (+ (cadr pt2) ph)))
   (setq pt4 (list (car pt1) (cadr pt3)))
   
   (setq dh (- ph 0.10))
   (setq db (- pb 0.10))

   (setq pd1 (list (+ (car pt1) 0.05) (+ (cadr pt1) 0.05)))
   (setq pd2 (list (+ (car pd1) db) (cadr pd1)))
   (setq pd3 (list (car pd2) (+ (cadr pd2) dh)))
   (setq pd4 (list (car pd1) (cadr pd3)))
   
   (setq po1 (list (- (car pt1) 0.05) (cadr pt1)))
   (setq po2 (list (car po1) (- (cadr po1) 0.03)))
   (setq po3 (list (+ (car pt2) 0.05) (- (cadr pt1) 0.03)))
   (setq po4 (list (car po3) (cadr pt2)))
    
    (command "COLOR" "white")
    (command "LINE" pt1 pt2 pt3 pt4 pt1 "")
    (command "LINE" pd1 pd2 pd3 pd4 pd1 "")
    (command "LINE" pt1 po1 po2 po3 po4 pt2 "")
   (command "LINETYPE" "S" "continuous" "")
   (setvar "BLIPMODE" 1)
   (setvar "ORTHOMODE" 0)
 )
;--------------------------------------------------------------------------
; Tek kanatli pencere cizimi

(defun pen-2 (/ ph pb pk pt1 pt2 pt3 pt4 )
   
   (command "LINETYPE" "S" "continuous" "")
   (initget 6)   
   (setq ph (getint "\nPencerenin [H] boyutunu <cm.> ver : "))
   (initget 6)   
   (setq pb (getint "\nPencerenin [B] boyutunu <cm.> ver : "))
   (initget 6)   
   (setq pk (getint "\nPencere kanat boyutunu  <cm.> ver : "))
   (initget 17)   
   (setq pt1 (getpoint "\nPencere ciziminin sol-alt kosesini isaretle: "))
   
   (setq ph (/ ph 100.0))
   (setq pb (/ pb 100.0))
   (setq pk (/ pk 100.0))

   (initget 6)   
   (setq py1 (getstring t (strcat "\nPencerenin kanat tarafini yazin <sol/sag>: ")))
 (if (or (= py1  "sag") (= py1 "SAG"))
  (progn
   (setq pt2 (list (+ (car pt1) pb) (cadr pt1)))
   (setq pt3 (list (car pt2) (+ (cadr pt2) ph)))
   (setq pt4 (list (car pt1) (cadr pt3)))
   
   (setq dh (- ph 0.10))
   (setq db1 (- pb (+ pk 0.15)))
   
   (setq pd1 (list (+ (car pt1) 0.05) (+ (cadr pt1) 0.05)))
   (setq pd2 (list (+ (car pd1) db1) (cadr pd1)))
   (setq pd3 (list (car pd2) (+ (cadr pd2) dh)))
   (setq pd4 (list (car pd1) (cadr pd3)))
   
   (setq pe1 (list (+ (car pd2) 0.05) (cadr pd2)))
   (setq pe2 (list (+ (car pe1) pk) (cadr pe1)))
   (setq pe3 (list (car pe2) (+ (cadr pe2) dh)))
   (setq pe4 (list (car pe1) (cadr pe3)))
   
   (setq pf1 (list (+ (car pe1) 0.05) (+ (cadr pe1) 0.05)))
   (setq pf2 (list (- (car pe2) 0.05) (+ (cadr pe2) 0.05)))
   (setq pf3 (list (- (car pe3) 0.05) (- (cadr pe3) 0.05)))
   (setq pf4 (list (+ (car pe4) 0.05) (- (cadr pe4) 0.05)))
   (setq pf5 (list (car pf1) (+ (cadr pe1) (/ dh 2.0))))
   
   (setq po1 (list (- (car pt1) 0.05) (cadr pt1)))
   (setq po2 (list (car po1) (- (cadr po1) 0.03)))
   (setq po3 (list (+ (car pt2) 0.05) (- (cadr pt1) 0.03)))
   (setq po4 (list (car po3) (cadr pt2)))
    
    (command "COLOR" "white")
    (command "LINE" pt1 pt2 pt3 pt4 pt1 "")
    (command "LINE" pd1 pd2 pd3 pd4 pd1 "")
    (command "LINE" pe1 pe2 pe3 pe4 pe1 "")
    (command "LINE" pf1 pf2 pf3 pf4 pf1 "")
    (command "LINE" pt1 po1 po2 po3 po4 pt2 "")
    (command "LINETYPE" "S" "dashed" "") 
    (command "LTSCALE" 0.2) 
    (command "LINE" pf3 pf5 pf2 "")
   )
  
  (progn
   (setq pt2 (list (+ (car pt1) pb) (cadr pt1)))
   (setq pt3 (list (car pt2) (+ (cadr pt2) ph)))
   (setq pt4 (list (car pt1) (cadr pt3)))
   
   (setq dh (- ph 0.10))
   (setq db1 (- pb (+ pk 0.15)))
   
   (setq pd1 (list (+ (car pt1) 0.05) (+ (cadr pt1) 0.05)))
   (setq pd2 (list (+ (car pd1) pk) (cadr pd1)))
   (setq pd3 (list (car pd2) (+ (cadr pd2) dh)))
   (setq pd4 (list (car pd1) (cadr pd3)))
   
   (setq pe1 (list (+ (car pd2) 0.05) (cadr pd2)))
   (setq pe2 (list (+ (car pe1) db1) (cadr pe1)))
   (setq pe3 (list (car pe2) (+ (cadr pe2) dh)))
   (setq pe4 (list (car pe1) (cadr pe3)))
   
   (setq pf1 (list (+ (car pd1) 0.05) (+ (cadr pd1) 0.05)))
   (setq pf2 (list (- (car pd2) 0.05) (+ (cadr pd2) 0.05)))
   (setq pf3 (list (- (car pd3) 0.05) (- (cadr pd3) 0.05)))
   (setq pf4 (list (+ (car pd4) 0.05) (- (cadr pd4) 0.05)))
   (setq pf5 (list (car pf2) (+ (cadr pd1) (/ dh 2.0))))
   
   (setq po1 (list (- (car pt1) 0.05) (cadr pt1)))
   (setq po2 (list (car po1) (- (cadr po1) 0.03)))
   (setq po3 (list (+ (car pt2) 0.05) (- (cadr pt1) 0.03)))
   (setq po4 (list (car po3) (cadr pt2)))
    
    (command "COLOR" "white")
    (command "LINE" pt1 pt2 pt3 pt4 pt1 "")
    (command "LINE" pd1 pd2 pd3 pd4 pd1 "")
    (command "LINE" pe1 pe2 pe3 pe4 pe1 "")
    (command "LINE" pf1 pf2 pf3 pf4 pf1 "")
    (command "LINE" pt1 po1 po2 po3 po4 pt2 "")
    (command "LINETYPE" "S" "dashed" "")
    (command "LTSCALE" 0.2 )
    (command "LINE" pf4 pf5 pf1 "")
   )
  )  
   (command "LINETYPE" "S" "continuous" "")
    (setvar "BLIPMODE" 1)
    (setvar "ORTHOMODE" 0)
 )
;--------------------------------------------------------------------------
; Cift kanatli pencere cizimi

(defun pen-3 (/ ph pb pk pt1 pt2 pt3 pt4 pd1 pd2 pd3 pd4 pe1 pe2 pe3 pe4)
   
   (command "LINETYPE" "S" "continuous" "")
   (initget 6)   
   (setq ph (getint "\nPencerenin [H] boyutunu <cm.> ver : "))
   (initget 6)   
   (setq pb (getint "\nPencerenin [B] boyutunu <cm.> ver : "))
   (initget 6)   
   (setq pk (getint "\nPencere kanat boyutunu  <cm.> ver : "))
   (initget 17)   
   (setq pt1 (getpoint "\nPencere ciziminin sol-alt kosesini isaretle: "))
   
   (setq ph (/ ph 100.0))
   (setq pb (/ pb 100.0))
   (setq pk (/ pk 100.0))

   (setq pt2 (list (+ (car pt1) pb) (cadr pt1)))
   (setq pt3 (list (car pt2) (+ (cadr pt2) ph)))
   (setq pt4 (list (car pt1) (cadr pt3)))
   
   (setq dh (- ph 0.10))
   (setq db1 (- pb (+ pk pk 0.20)))
   
   (setq pd1 (list (+ (car pt1) (+ pk 0.10)) (+ (cadr pt1) 0.05)))
   (setq pd2 (list (+ (car pd1) db1) (cadr pd1)))
   (setq pd3 (list (car pd2) (+ (cadr pd2) dh)))
   (setq pd4 (list (car pd1) (cadr pd3)))
   
   (setq po1 (list (- (car pt1) 0.05) (cadr pt1)))
   (setq po2 (list (car po1) (- (cadr po1) 0.03)))
   (setq po3 (list (+ (car pt2) 0.05) (- (cadr pt1) 0.03)))
   (setq po4 (list (car po3) (cadr pt2)))
   
   (setq pe1 (list (+ (car pd2) 0.05) (cadr pd2)))
   (setq pe2 (list (+ (car pe1) pk) (cadr pe1)))
   (setq pe3 (list (car pe2) (+ (cadr pe2) dh)))
   (setq pe4 (list (car pe1) (cadr pe3)))
   
   (setq pf1 (list (+ (car pe1) 0.05) (+ (cadr pe1) 0.05)))
   (setq pf2 (list (- (car pe2) 0.05) (+ (cadr pe2) 0.05)))
   (setq pf3 (list (- (car pe3) 0.05) (- (cadr pe3) 0.05)))
   (setq pf4 (list (+ (car pe4) 0.05) (- (cadr pe4) 0.05)))
   (setq pf5 (list (car pf1) (+ (cadr pe1) (/ dh 2.0))))
   
   (setq pg1 (list (+ (car pt1) 0.05) (+ (cadr pt1) 0.05)))
   (setq pg2 (list (+ (car pg1) pk) (cadr pg1)))
   (setq pg3 (list (car pg2) (+ (cadr pg2) dh)))
   (setq pg4 (list (car pg1) (cadr pg3)))
   
   (setq pj1 (list (+ (car pg1) 0.05) (+ (cadr pg1) 0.05)))
   (setq pj2 (list (- (car pg2) 0.05) (+ (cadr pg2) 0.05)))
   (setq pj3 (list (- (car pg3) 0.05) (- (cadr pg3) 0.05)))
   (setq pj4 (list (+ (car pg4) 0.05) (- (cadr pg4) 0.05)))
   (setq pj5 (list (car pj2) (+ (cadr pg2) (/ dh 2.0))))
   
    (command "COLOR" "white")
    (command "LINE" pt1 pt2 pt3 pt4 pt1 "")
    (command "LINE" pt1 po1 po2 po3 po4 pt2 "")
    (command "LINE" pd1 pd2 pd3 pd4 pd1 "")
    (command "LINE" pe1 pe2 pe3 pe4 pe1 "")
    (command "LINE" pf1 pf2 pf3 pf4 pf1 "")
    (command "LINE" pg1 pg2 pg3 pg4 pg1 "")
    (command "LINE" pj1 pj2 pj3 pj4 pj1 "")
    
    (command "LINETYPE" "S" "dashed" "")
    (command "LTSCALE" 0.2) 
    (command "LINE" pf3 pf5 pf2 "")
    (command "LINE" pj4 pj5 pj1 "")
    
   (command "LINETYPE" "S" "continuous" "")
    (setvar "BLIPMODE" 1)
    (setvar "ORTHOMODE" 0)
 )
;--------------------------------------------------------------------------
;Error aciklama

(defun cizerr (s)              
                               
   (if (/= s "Function cancelled")
       (princ (strcat "\nError: " s))
   )
   (if undoit
      (progn
         (command)
         (command "UNDO" "e")  
         (princ "\nundoing...") 
         (command "U")         
       )
      (command "UNDO" "e")               
   )
   (moder)    
   (command "REDRAWALL")
   (setvar "CMDECHO" oce)    
   (setq *error* olderr)     
   (princ)

)

;--------------------------------------------------------------------------

(defun ciz (key / olderr)
   (if m:err                  
      (setq olderr m:err *error* cizerr) 
      (setq olderr *error* *error* cizerr)
   )
   (setq undoit nil)
   (setq oce (getvar "cmdecho"))
   (setvar "CMDECHO" 0)
   (modes '("BLIPMODE" "GRIDMODE" "ORTHOMODE" "OSMODE"
            "SURFTAB1" "SURFTAB2" "UCSFOLLOW"))
   (command "UNDO" "group")
   (setvar "UCSFOLLOW" 0)
   (setvar "GRIDMODE" 0)
   (setvar "OSMODE" 0)
   (if (null key)
       (progn
           (initget "pen-1 pen-2 pen-3")
           (setq key (getkword "\nPen-1/Pen-2/Pen-3 : "))
       )
   )
   (cond ((= key "pen-1") (pen-1)) 
         ((= key "pen-2") (pen-2)) 
         ((= key "pen-3") (pen-3)) 
         (T nil)                     
   )
   (moder)                           
   (command "REDRAWALL")
   (command "UNDO" "e")              
   (setvar "CMDECHO" oce)            
   (setq *error* olderr)             
   (princ)
)

;--------------------------------------------------------------------------

(defun C:PEN-1 () (ciz "pen-1"))
(defun C:PEN-2 () (ciz "pen-2"))
(defun C:PEN-3 () (ciz "pen-3"))
(defun C:PENCERE ()  (ciz nil))
